=begin
#Messente API

#[Messente](https://messente.com) is a global provider of messaging and user verification services.  * Send and receive SMS, Viber, WhatsApp and Telegram messages. * Manage contacts and groups. * Fetch detailed info about phone numbers. * Blacklist phone numbers to make sure you're not sending any unwanted messages.  Messente builds [tools](https://messente.com/documentation) to help organizations connect their services to people anywhere in the world.

The version of the OpenAPI document: 1.4.0
Contact: messente@messente.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module MessenteApi
  class StatisticsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Requests statistics reports for each country
    # @param statistics_report_settings [StatisticsReportSettings] Settings for statistics report
    # @param [Hash] opts the optional parameters
    # @return [StatisticsReportSuccess]
    def create_statistics_report(statistics_report_settings, opts = {})
      data, _status_code, _headers = create_statistics_report_with_http_info(statistics_report_settings, opts)
      data
    end

    # Requests statistics reports for each country
    # @param statistics_report_settings [StatisticsReportSettings] Settings for statistics report
    # @param [Hash] opts the optional parameters
    # @return [Array<(StatisticsReportSuccess, Integer, Hash)>] StatisticsReportSuccess data, response status code and response headers
    def create_statistics_report_with_http_info(statistics_report_settings, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: StatisticsApi.create_statistics_report ...'
      end
      # verify the required parameter 'statistics_report_settings' is set
      if @api_client.config.client_side_validation && statistics_report_settings.nil?
        fail ArgumentError, "Missing the required parameter 'statistics_report_settings' when calling StatisticsApi.create_statistics_report"
      end
      # resource path
      local_var_path = '/statistics/reports'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(statistics_report_settings) 

      # return_type
      return_type = opts[:return_type] || 'StatisticsReportSuccess' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: StatisticsApi#create_statistics_report\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
